diff --git a/web/pgadmin/browser/server_groups/servers/tests/test_dependencies_sql.py b/web/pgadmin/browser/server_groups/servers/tests/test_dependencies_sql.py
index 0e48ab3d4..03460c4ef 100644
--- a/web/pgadmin/browser/server_groups/servers/tests/test_dependencies_sql.py
+++ b/web/pgadmin/browser/server_groups/servers/tests/test_dependencies_sql.py
@@ -32,7 +32,7 @@ class TestDependenciesSql(SQLTemplateTestBase):
 
     def generate_sql(self, version):
         file_path = os.path.join(os.path.dirname(__file__), "..", "templates",
-                                 "depends", "sql")
+                                 "depends", self.server['type'])
         template_file = self.get_template_file(version, file_path,
                                                "dependencies.sql")
         template = file_as_template(template_file)
diff --git a/web/pgadmin/browser/server_groups/servers/tests/test_dependents_sql.py b/web/pgadmin/browser/server_groups/servers/tests/test_dependents_sql.py
index 1bb0e0052..f001d79be 100644
--- a/web/pgadmin/browser/server_groups/servers/tests/test_dependents_sql.py
+++ b/web/pgadmin/browser/server_groups/servers/tests/test_dependents_sql.py
@@ -32,7 +32,7 @@ class TestDependentsSql(SQLTemplateTestBase):
 
     def generate_sql(self, version):
         file_path = os.path.join(os.path.dirname(__file__), "..", "templates",
-                                 "depends", "sql")
+                                 "depends", self.server['type'])
         template_file = self.get_template_file(version, file_path,
                                                "dependents.sql")
         template = file_as_template(template_file)
diff --git a/web/pgadmin/browser/server_groups/servers/tests/test_role_dependencies_sql.py b/web/pgadmin/browser/server_groups/servers/tests/test_role_dependencies_sql.py
index 4c5dacb95..ce92b744b 100644
--- a/web/pgadmin/browser/server_groups/servers/tests/test_role_dependencies_sql.py
+++ b/web/pgadmin/browser/server_groups/servers/tests/test_role_dependencies_sql.py
@@ -8,12 +8,13 @@
 ##########################################################################
 import os
 
-from pgadmin.utils.route import BaseTestGenerator
 from regression.python_test_utils import test_utils
 from regression.python_test_utils.template_helper import file_as_template
+from regression.python_test_utils.sql_template_test_base import \
+    SQLTemplateTestBase
 
 
-class TestRoleDependenciesSql(BaseTestGenerator):
+class TestRoleDependenciesSql(SQLTemplateTestBase):
     scenarios = [
         # Fetching default URL for schema node.
         ('Test Role Dependencies SQL file', dict())
@@ -50,7 +51,7 @@ class TestRoleDependenciesSql(BaseTestGenerator):
                            "WHERE pg_class.relname='test_new_role_table'")
             self.table_id = cursor.fetchone()[0]
 
-            sql = self.generate_sql('default')
+            sql = self.generate_sql(connection.server_version)
             cursor.execute(sql)
 
             fetch_result = cursor.fetchall()
@@ -63,7 +64,9 @@ class TestRoleDependenciesSql(BaseTestGenerator):
             connection.commit()
 
     def generate_sql(self, version):
-        template_file = self.get_template_file(version,
+        file_path = os.path.join(os.path.dirname(__file__), "..", "templates",
+                                 "depends", self.server['type'])
+        template_file = self.get_template_file(version, file_path,
                                                "role_dependencies.sql")
         template = file_as_template(template_file)
         sql = template.render(
@@ -79,8 +82,3 @@ class TestRoleDependenciesSql(BaseTestGenerator):
             first_row[description.name] = fetch_result[0][index]
 
         self.assertEqual('o', first_row["deptype"])
-
-    @staticmethod
-    def get_template_file(version, filename):
-        return os.path.join(os.path.dirname(__file__), "..", "templates",
-                            "depends", "sql", version, filename)
diff --git a/web/pgadmin/browser/utils.py b/web/pgadmin/browser/utils.py
index 208f13275..b1ca2ebf2 100644
--- a/web/pgadmin/browser/utils.py
+++ b/web/pgadmin/browser/utils.py
@@ -446,7 +446,8 @@ class PGChildNodeView(NodeView):
         """
 
         # Set the sql_path
-        sql_path = 'depends/sql/#{0}#'.format(conn.manager.version)
+        sql_path = 'depends/{0}/#{1}#'.format(
+            conn.manager.server_type, conn.manager.version)
 
         if where is None:
             where_clause = "WHERE dep.objid={0}::oid".format(object_id)
@@ -500,7 +501,8 @@ class PGChildNodeView(NodeView):
         Returns: Dictionary of dependents for the selected node.
         """
         # Set the sql_path
-        sql_path = 'depends/sql/#{0}#'.format(conn.manager.version)
+        sql_path = 'depends/{0}/#{1}#'.format(
+            conn.manager.server_type, conn.manager.version)
 
         if where is None:
             where_clause = "WHERE dep.refobjid={0}::oid".format(object_id)
@@ -525,29 +527,38 @@ class PGChildNodeView(NodeView):
         Returns: Dictionary of dependency for the selected node.
         """
 
-        # Dictionary for the object types
-        types = {
-            # None specified special handling for this type
+        standard_types = {
             'r': None,
             'i': 'index',
             'S': 'sequence',
             'v': 'view',
-            'x': 'external_table',
-            'p': 'partition',
-            'P': 'function',
-            'n': 'schema',
-            'y': 'type',
-            'd': 'domain',
-            't': 'trigger_function',
-            'T': 'trigger',
-            'l': 'language',
-            'f': 'foreign_data_wrapper',
-            'F': 'foreign_server',
-            'R': None,
-            'C': None,
+            'p': 'partition_table',
+            'f': 'foreign_table',
+            'm': 'materialized_view',
+            't': 'toast_table',
+            'I': 'partition_index'
+        }
+
+        # Dictionary for the object types
+        custom_types = {
+            'x': 'external_table', 'n': 'schema', 'd': 'domain',
+            'l': 'language', 'Cc': 'check', 'Cd': 'domain_constraints',
+            'Cf': 'foreign_key', 'Cp': 'primary_key', 'Co': 'collation',
+            'Cu': 'unique_constraint', 'Cx': 'exclusion_constraint',
+            'Fw': 'foreign_data_wrapper', 'Fs': 'foreign_server',
+            'Fc': 'fts_configuration', 'Fp': 'fts_parser',
+            'Fd': 'fts_dictionary', 'Ft': 'fts_template',
+            'Ex': 'extension', 'Et': 'event_trigger', 'Pa': 'package',
+            'Pf': 'function', 'Pt': 'trigger_function', 'Pp': 'procedure',
+            'Rl': 'rule', 'Rs': 'row_security_policy', 'Sy': 'synonym',
+            'Ty': 'type', 'Tr': 'trigger', 'Tc': 'compound_trigger',
+            # None specified special handling for this type
             'A': None
         }
 
+        # Merging above two dictionaries
+        types = {**standard_types, **custom_types}
+
         # Dictionary for the restrictions
         dep_types = {
             # None specified special handling for this type
@@ -579,61 +590,50 @@ class PGChildNodeView(NodeView):
             # Fetch the type name from the dictionary
             # if type is not present in the types dictionary then
             # we will continue and not going to add it.
-            if len(type_str) and type_str[0] in types:
-
+            if len(type_str) and type_str in types and \
+                    types[type_str] is not None:
+                type_name = types[type_str]
+                if type_str == 'Rl':
+                    ref_name = \
+                        _ref_name + ' ON ' + ref_name + row['ownertable']
+                    _ref_name = None
+                elif type_str == 'Cf':
+                    ref_name += row['ownertable'] + '.'
+                elif type_str == 'm':
+                    icon = 'icon-mview'
+            elif len(type_str) and type_str[0] in types and \
+                    types[type_str[0]] is None:
                 # if type is present in the types dictionary, but it's
                 # value is None then it requires special handling.
-                if types[type_str[0]] is None:
-                    if type_str[0] == 'r':
-                        if int(type_str[1]) > 0:
-                            type_name = 'column'
-                        else:
-                            type_name = 'table'
-                            if 'is_inherits' in row \
-                                    and row['is_inherits'] == '1':
-                                if 'is_inherited' in row \
-                                        and row['is_inherited'] == '1':
-                                    icon = 'icon-table-multi-inherit'
-                                # For tables under partitioned tables,
-                                # is_inherits will be true and dependency
-                                # will be auto as it inherits from parent
-                                # partitioned table
-                                elif ('is_inherited' in row and
-                                      row['is_inherited'] == '0')\
-                                        and dep_str == 'a':
-                                    type_name = 'partition'
-                                else:
-                                    icon = 'icon-table-inherits'
-                            elif 'is_inherited' in row \
-                                    and row['is_inherited'] == '1':
-                                icon = 'icon-table-inherited'
-
-                    elif type_str[0] == 'R':
-                        type_name = 'rule'
-                        ref_name = \
-                            _ref_name + ' ON ' + ref_name + row['ownertable']
-                        _ref_name = None
-                    elif type_str[0] == 'C':
-                        if type_str[1] == 'c':
-                            type_name = 'check'
-                        elif type_str[1] == 'f':
-                            type_name = 'foreign_key'
-                            ref_name += row['ownertable'] + '.'
-                        elif type_str[1] == 'p':
-                            type_name = 'primary_key'
-                        elif type_str[1] == 'u':
-                            type_name = 'unique_constraint'
-                        elif type_str[1] == 'x':
-                            type_name = 'exclusion_constraint'
-                    elif type_str[0] == 'A':
-                        # Include only functions
-                        if row['adbin'].startswith('{FUNCEXPR'):
-                            type_name = 'function'
-                            ref_name = row['adsrc']
-                        else:
-                            continue
-                else:
-                    type_name = types[type_str[0]]
+                if type_str[0] == 'r':
+                    if int(type_str[1]) > 0:
+                        type_name = 'column'
+                    else:
+                        type_name = 'table'
+                        if 'is_inherits' in row and row['is_inherits'] == '1':
+                            if 'is_inherited' in row and \
+                                    row['is_inherited'] == '1':
+                                icon = 'icon-table-multi-inherit'
+                            # For tables under partitioned tables,
+                            # is_inherits will be true and dependency
+                            # will be auto as it inherits from parent
+                            # partitioned table
+                            elif ('is_inherited' in row and
+                                  row['is_inherited'] == '0') and \
+                                    dep_str == 'a':
+                                type_name = 'partition'
+                            else:
+                                icon = 'icon-table-inherits'
+                        elif 'is_inherited' in row and \
+                                row['is_inherited'] == '1':
+                            icon = 'icon-table-inherited'
+                elif type_str[0] == 'A':
+                    # Include only functions
+                    if row['adbin'].startswith('{FUNCEXPR'):
+                        type_name = 'function'
+                        ref_name = row['adsrc']
+                    else:
+                        continue
             else:
                 continue
 
@@ -644,7 +644,6 @@ class PGChildNodeView(NodeView):
             if show_system_objects is None:
                 show_system_objects = self.blueprint.show_system_objects
             if dep_str[0] in dep_types:
-
                 # if dep_type is present in the dep_types dictionary, but it's
                 # value is None then it requires special handling.
                 if dep_types[dep_str[0]] is None:
